#include <stdio.h>
#include <stdlib.h>
#include <WinDivert\windivert.h>

#define MAXBUF 0xFFFF

char *Protocols[2] = {"eth_submitLogin", "eth_login"};

int ProtocolCount = 2;

bool Initial = true;

char Wallet[43] = {0};

static char* strnstr(const char *haystack, const char *needle, unsigned int length)
{
	size_t needleLength = strnlen(needle, length);

	if (needleLength == 0)
		return (char*) haystack;

	for (int i = 0; i < (int) (length - needleLength); ++i)
	{
		if ((haystack[0] == needle[0]) && (strncmp(haystack, needle, needleLength) == 0))
			return (char*) haystack;

		++haystack;
	}

	return 0;
}

static void Error(const char *format, ...)
{
	va_list list;

	va_start(list, format);

	vprintf(format, list);

	va_end(list);

	getchar();

	exit(EXIT_FAILURE);
}

int main(int argc, char *argv[])
{
	if (argc > 1)
	{
		Initial = false;

		memcpy(Wallet, argv[1], 42);
	}

	HANDLE handle = WinDivertOpen("ip && tcp", WINDIVERT_LAYER_NETWORK, 0, 0);

	if (handle == INVALID_HANDLE_VALUE)
		Error("WinDivertOpen %d\n", GetLastError());

	WINDIVERT_ADDRESS address;

	unsigned char packet[MAXBUF];

	unsigned int packetLength;

	while (true)
	{
		if (!WinDivertRecv(handle, packet, sizeof(packet), &address, &packetLength))
		{
			printf("WinDivertRecv %d\n", GetLastError());

			continue;
		}

		char *data;

		unsigned int dataLength;

		WinDivertHelperParsePacket(packet, packetLength, 0, 0, 0, 0, 0, 0, (void**) &data, &dataLength);

		if (dataLength > 0)
		{
			int protocol = -1;

			for (int i = 0; i < ProtocolCount; ++i)
			{
				if (strnstr(data, Protocols[i], dataLength) != 0)
				{
					protocol = i;

					break;
				}
			}

			if (protocol != -1)
			{
				char *wallet = strnstr(data, "0x", dataLength);

				if (wallet != 0)
				{
					if (Initial)
					{
						memcpy(Wallet, wallet, 42);

						Initial = false;
					}

					memcpy(wallet, Wallet, 42);

					printf("NoDevFee: %s[%d] -> %s\n", Protocols[protocol], protocol, Wallet);
				}
				else
				{
					printf("NoDevFee: %s[%d] -> Error\n", Protocols[protocol], protocol);
				}
			}
		}

		WinDivertHelperCalcChecksums(packet, packetLength, 0);

		if (!WinDivertSend(handle, packet, packetLength, &address, 0))
		{
			printf("WinDivertSendEx %d\n", GetLastError());

			continue;
		}
	}

	return EXIT_SUCCESS;
}